commit 2e33da576bc08e78020bbb6642b70eccb108192b
Author: José Rui Faustino de Sousa <jrfsousa@gmail.com>
Date:   Fri Sep 2 21:35:22 2022 +0200

    Fortran: Fix ICE with automatic reallocation [PR100245]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/100245
            * trans-expr.c (trans_class_assignment): Add if clause to handle
            derived type in the LHS.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/100245
            * gfortran.dg/PR100245.f90: New test.
    
    (cherry picked from commit 504424f33771be0405454e7845219d5df1bb88bb)

diff --git a/gcc/fortran/trans-expr.c b/gcc/fortran/trans-expr.c
index 5f4a464b0f9..82341f65e28 100644
--- a/gcc/fortran/trans-expr.c
+++ b/gcc/fortran/trans-expr.c
@@ -10904,6 +10904,9 @@ trans_class_assignment (stmtblock_t *block, gfc_expr *lhs, gfc_expr *rhs,
       class_han = GFC_CLASS_TYPE_P (TREE_TYPE (lse->expr))
 	  ? gfc_class_data_get (lse->expr) : lse->expr;
 
+      if (!POINTER_TYPE_P (TREE_TYPE (class_han)))
+	class_han = gfc_build_addr_expr (NULL_TREE, class_han);
+
       /* Allocate block.  */
       gfc_init_block (&alloc);
       gfc_allocate_using_malloc (&alloc, class_han, size, NULL_TREE);
diff --git a/gcc/testsuite/gfortran.dg/PR100245.f90 b/gcc/testsuite/gfortran.dg/PR100245.f90
new file mode 100644
index 00000000000..07c1f7b3a1c
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/PR100245.f90
@@ -0,0 +1,28 @@
+! { dg-do run }
+!
+! Test the fix for PR100245
+!
+
+program main_p
+
+  implicit none
+
+  type :: foo_t
+    integer :: a
+  end type foo_t
+
+  integer, parameter :: a = 42
+
+  class(foo_t), allocatable :: val
+  class(foo_t), allocatable :: rs1
+  type(foo_t),  allocatable :: rs2
+
+  allocate(val, source=foo_t(42))
+  if (val%a/=a) stop 1
+  rs1 = val
+  if (rs1%a/=a) stop 2
+  rs2 = val
+  if (rs2%a/=a) stop 3
+  deallocate(val, rs1, rs2)
+
+end program main_p

